---

.cluster-init-before-script:
  before_script:
    - |
      if [[ $LOG_LEVEL == "debug" ]]; then
         echo "A high debug level may expose secrets, this job will now exit..."
         exit 1
      fi
    - eval $(./bin/k-ctl config 2>/dev/null)
    - |
      if [[ $DRY_RUN == "false" ]]; then
        echo 'Using SERVICE_KEY'
        gcloud auth activate-service-account --key-file $SERVICE_KEY
      else
        echo 'Using SERVICE_KEY_RO'
        gcloud auth activate-service-account --key-file $SERVICE_KEY_RO
      fi
    - gcloud config set project $PROJECT
    - gcloud container clusters get-credentials ${CLUSTER} --region ${REGION}
    # Configure SSH authentication for the helm-git plugin
    - chmod 400 "$SSH_PRIVATE_KEY"
    - export GIT_SSH_COMMAND="ssh -i $SSH_PRIVATE_KEY -o IdentitiesOnly=yes -o GlobalKnownHostsFile=$SSH_KNOWN_HOSTS"
    - |
      if [[ -f "./gitlab-0.0.0+$CHART_VERSION.tgz" ]]; then
        export ARTIFACT_AVAILABLE=true
        echo "Using chart from artifact"
        tar xf gitlab-0.0.0+$CHART_VERSION.tgz
      else
        echo "Using chart from git repo"
      fi
    -
      |
        # For logging events
        # https://gitlab.com/gitlab-com/runbooks/-/blob/master/docs/events/README.md
        sendEvent() {
          if [[ -z "$ES_NONPROD_EVENTS_URL" || $ES_EVENT_OVERRIDE == "true" ]]; then
            echo "Warning: Not sending events because ES_NONPROD_EVENTS_URL is not set or ES_EVENT_OVERRIDE is set to true"
            return
          fi
          command -v curl >/dev/null 2>&1 || \
            { echo >&2 "sending events requires curl but it's not installed."; return; }
          MSG="$1"
          ENV="$2"
          TYPE="$3"
          STAGE="${4:-main}"
          TS=$(date -u +%s000)
          USERNAME="${GITLAB_USER_LOGIN:-unknown}"
          SOURCE="${CI_JOB_URL:-unknown}"
          image_tag="${GITLAB_IMAGE_TAG:-$COMPONENT_VERSION}"
          VERSION="${image_tag:-not set}"
          DATA="
            {
              \"time\": \"$TS\",
              \"type\": \"$TYPE\",
              \"message\": \"$MSG\",
              \"env\": \"$ENV\",
              \"username\": \"$USERNAME\",
              \"source\": \"$SOURCE\",
              \"version\": \"$VERSION\",
              \"stage\": \"$STAGE\"
            }
          "
          echo "Sending event: \"$MSG\""
          curl -s -X POST \
            --retry 5 \
            --retry-max-time 20 \
            "$ES_NONPROD_EVENTS_URL/events-${ENV/-cny/}/_doc" -H 'Content-Type: application/json' -d "$DATA" > /dev/null
        }
